//
//  TKPXMResource.h
//  ThemeKit
//
//  Created by David Watson on Mon Dec 08 2003.
//  Copyright (c) 2003 Carpe Stellarem. All rights reserved.
//

#ifndef _TKPXMResource_
#define __TKPXMResource__

#import <Foundation/Foundation.h>
#import "TKResource.h"

typedef struct PXMHeader {
    Rect	mBounds;
    SInt16      mMaskCount;
    SInt16      mPixelDepth;
    SInt16      mCTSeedValue;
    SInt16      mImageCount;	
} PXMHeader;


enum pxmTypes {CSPXMImage=0, CSPXMTransparent, CSPXMMask, CSPXMComposite};

@interface TKPXMResource : TKResource {
        PXMHeader       pxmHeader;

}

-(void)parseHeader;
+(id)pxmWithData:(NSData *)inData;
-(NSImage *)getImage:(int)index type:(int)inType;
-(void)setImage:(NSImage *)inImage atIndex:(int)index type:(int)inType;
-(int)numImages;
-(id)initWithData:(NSData *)inData;
@end

#endif
